program ub;
{$APPTYPE CONSOLE}
{           EA  (mu,lambda)-}
{  RR-functions}
{    .. , .. . 
"         ".
   . 2020.}
{The 4-letters alphabet is used. Allele = number from 1 to 4.}
uses
  delp_mem,
  SysUtils,
  matr11;
const
  max_allele_val = 4;
var
   mu: integer; {the number of selectable individuals mu}
   blocklength:integer;
   c,c1,st:char;
   l:integer; {number of blocks}
   two_options_positions:integer; {number of block positions with two options acceptable for consensus}
   i,j,popsize,gen,dr,md:integer;
   max,avg,min,ax,r,rr,alpht:extended;
   kk,k,maxgen,maxgen1,maxgen0,genstep:integer;
   lchrom,ncross,nmutation:integer;
   pinversion:extended;
   b01,b02,b11,b12,b21,b22,x1,x2,y1,y2,x_1,x_2,y_1,y_2:extended;
   x,y,accum,accum1:tvector;A:tmatrix0;b:boolean;


 procedure first_initialize;
 var
   i,j:integer;
 begin

   writeln;
   writeln('Enter population size (at most ',maxpop,'):');readln(popsize);
   writeln('Enter allele mutation probability:');readln(pinversion);
   writeln('Enter block length (at most ',maxstring,'):');readln(blocklength);
   writeln('how many block positions with two options acceptable (at most ',blocklength,'):');readln(two_options_positions);
   writeln('The number of blocks l (at most ',maxstring div blocklength,'):');readln(l);
   lchrom:=l*blocklength;
   writeln('The final iteration number:');readln(maxgen1);
   writeln('The number of generations in one step in the output:');readln(genstep);
   writeln('Enter parameter mu (at most ',popsize,'):');readln(mu);
   maxgen0:=genstep;
   writeln('Output file name:');readln(stri);
   assign(fil,stri);
   rewrite(fil);
   writeln(fil,'block length=',blocklength);
   writeln(fil,'number of blocks=',l);
   writeln(fil,'number of block positions with two options acceptable=',two_options_positions);
   writeln(fil,'length of chromosome =',lchrom);
   writeln(fil,'Number of fitness levels = ',l+1);
   writeln(fil,'Population size lambda=',popsize);
   writeln(fil,'Pmut=',(pinversion):5:5);
   writeln(fil,'Number of selectable (current best) individuals mu= ',mu);
 end;


function fact(x:integer):longint;
var i,j:longint;
begin
  j:=1;
  for i:=1 to x do j:=j*i;
  fact:=j;
end;

function fact_real(x:longint):extended;
var i:longint; j:extended;
begin
  j:=1;
  for i:=1 to x do j:=j*i;
  fact_real:=j;
end;

function CC_real(n,k:longint):extended;
begin
  CC_real:=fact_real(n)/(fact_real(k)*fact_real(n-k));
end;


function CC(n,k:integer):longint;
begin
  CC:=fact(n) div (fact(k)*fact(n-k));
end;



function p1(k,j:integer;p:extended):extended;
{Computes the cumulative transition probabilities (case 1)}
var q,p10,p11,p00,p01,r,s,s1:extended; i,t:integer; minim:integer;
begin
  q:=1-p;
  if two_options_positions>0 then
  begin
    p01:=2*p/(max_allele_val-1); p00:=1-p01;
    p11:=pow(q+p/(max_allele_val-1),two_options_positions)*
                pow(q,blocklength-two_options_positions);
    p10:=1-p11;
  end
  else
  begin
    p01:=p/(max_allele_val-1); p00:=1-p01;
    p11:=pow(q,blocklength); p10:=1-p11;
  end;

  s:=0;
  for i:=0 to l-k do
  begin
    r:=cc_real(l-k,i)*pow(p01,i)*pow(p00,l-k-i);
    s1:=0;
    minim:=k-j+i;
    if k<minim then minim:=k;
    for t:=0 to minim do
      s1:=s1+cc_real(k,t)*pow(p10,t)*pow(p11,k-t);
    s:=s+r*s1;
  end;
  p1:=s;
end;

function one_minus_Pch(z_i:extended;mu1,lambda1:integer):extended;
begin
 if z_i>=mu1/lambda1 then  one_minus_Pch:=0
  else one_minus_Pch:=1-z_i*lambda1/mu1;
end;

function p2(k,j:integer;p:extended):extended;
{Computes the cumulative transition probabilities (case 2)}
var q,p10,p11,p00,p01,r,s,s1:extended; i,t:integer;
begin
  q:=1-p;
  if two_options_positions>0 then
  begin
    p01:=2*p/(max_allele_val-1); p00:=1-p01;
    p11:=pow(q+p/(max_allele_val-1),blocklength); p10:=1-p11;
  end
  else
  begin
    p01:=p/(max_allele_val-1); p00:=1-p01;
    p11:=pow(q,blocklength); p10:=1-p11;
  end;

  s:=0;
  for i:=0 to k do
  begin
    r:=cc_real(k,i)*pow(p10,i)*pow(p11,k-i);
    s1:=0;
    for t:=j-k+i to l-k do
      s1:=s1+cc_real(l-k,t)*pow(p01,t)*pow(p00,l-k-t);
    s:=s+r*s1;
  end;
  p2:=s;
end;

procedure initA_and_x(f0,p:extended);
var
    b:boolean;
    q:extended;
    i,j,k:longint;
begin
  q:=1-p;
  x.createzero(l,b);
  y.createzero(l,b);
  accum.createzero(l,b);accum1.createzero(l,b);
{  writeln('creat');}
  A.createzero(l,b);
  for i:=1 to l do
    x.put(f0,i);
  for i:=1 to l do
    y.put(f0,i);
{  writeln('for');}
  for k:=0 to l do
  begin
    for j:=1 to k do
      A.put(p1(k,j,p),k,j);
    if k<l then
      for j:=k+1 to l do
        A.put(p2(k,j,p),k,j);
  end;
end;


procedure doneA_and_x(f0,p:extended);
var
    b:boolean;
    q:extended;
    i,j,k:longint;
begin
  x.done; accum.done;accum1.done;y.done;
  A.done;
end;

 begin
   first_initialize;
   r:=pow(1-pinversion,lchrom);
   rr:=pow(pinversion,lchrom);
   maxgen:=maxgen0;
   initA_and_x(f0,pinversion);

   write(fil,'  Xl_1(',maxgen,')= ',f0:3:3);
   writeln(fil,' <=',f0:3:3);

   for kk:=1 to genstep do
   begin
     for i:=1 to l do
       accum.put(x.get(i),i);
     for j:=1 to l do
     begin
       r:=0;
       for k:=1 to l do
         r:=r+one_minus_Pch(x.get(k),mu,popsize)*(A.get(k-1,j)-A.get(k,j));
       r:=r+A.get(l,j);
       accum.put(r,j);
     end;
     for i:=1 to l do
       x.put(accum.get(i),i);

     for i:=1 to l do
       accum.put(y.get(i),i);
     for j:=1 to l do
     begin
       r:=0;
       for k:=1 to l do
         r:=r+y.get(k)*(A.get(k,j)-A.get(k-1,j));
       r:=r+A.get(0,j);
       accum.put(r,j);
     end;
     for i:=1 to l do
       y.put(accum.get(i),i);
   end;

   r:=A.get(1,1);
   rr:=A.get(0,1);

    write('Xl(',maxgen,')');
    write(' <=',x.get(l):3:3);
    if l>1 then
    begin
     write('  X_(l-1)(',maxgen,')');
     write(' <=',x.get(l-1):3:3);
    end;

    if l>2 then
    begin
     write('  X_(l-2)(',maxgen,')');
     writeln(' <=',x.get(l-2):3:3);
    end;

    write(fil,'Xl(',maxgen,')');
    write(fil,' <=',x.get(l):10:6);
    if l>1 then
    begin
      write(fil,'  Xl_1(',maxgen,')');
      write(fil,' <=',x.get(l-1):10:6);
    end;
    if l>2 then
    begin
     write(fil,'  X_(l-2)(',maxgen,')');
     writeln(fil,' <=',x.get(l-2):10:6);
    end;

   maxgen:=maxgen+genstep;
   until maxgen>maxgen1;
   close(fil);
 end.


